;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : AT90S8535
;Clock frequency     : 4,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 135 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Automatic register allocation : On

	.DEVICE AT90S8535
	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0x30
	.EQU __sm_powerdown=0x20

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "ps2.vec"
	.INCLUDE "ps2.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE7)
	LDI  R29,HIGH(0xE7)

	RJMP _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0xE7
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.0.2.2d Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2002
;       6 Pavel Haiduc, HP InfoTech s.r.l.
;       7 http://www.hpinfotech.ro
;       8 e-mail:office@hpinfotech.ro , hpinfotech@xmail.ro
;       9 
;      10 Project : TP4 Pousse Seringue
;      11 Version : 1
;      12 Date    : 03/2003
;      13 Author  : Philippe Mariano                
;      14 Company : LYCEE Pierre Emile MARTIN       
;      15 Comments: Rorganisation de la fonction traiter du PS
;      16 
;      17 
;      18 Chip type           : AT90S8535
;      19 Clock frequency     : 4,000000 MHz
;      20 Memory model        : Small
;      21 Internal SRAM size  : 512
;      22 External SRAM size  : 0
;      23 Data Stack size     : 128
;      24 *********************************************/
;      25 
;      26 #include <90s8535.h>
;      27 
;      28 // Librairies non gnres par Wizard (rajoutes manuellement)      
;      29 #include <ssi.h>      // contient les fonctions Lire_BP,Affiche_LCD,Regdebit,Select_Seringue 
;      30 #include <delay.h>    // contient la fonction delay_ms
;      31 #include <stdio.h>    // contient la fonction sprintf
;      32 
;      33 // Etats du graphe des transitions "Menu"
;      34 #define Arret	 	0
;      35 #define Marche	 	1
;      36 #define ReglageDebit	2    
;      37 #define ChoixSeringue	3
;      38 
;      39 // Etats du graphe des transitions "Moteur"
;      40 #define etat0	0
;      41 #define etat1	1
;      42 #define etat2	2
;      43 #define etat3	3
;      44 
;      45 // Code des BPs de la carte AT90S8535 SSI
;      46 #ifndef INC 
;      47 #define INC	0x1F  
;      48 #endif 
;      49 #ifndef DEC 
;      50 #define DEC	0x2F
;      51 #endif 
;      52 #ifndef OK
;      53 #define OK	0x37
;      54 #endif 
;      55 #ifndef ECHAP
;      56 #define ECHAP	0x3B
;      57 #endif 
;      58 #ifndef SET
;      59 #define SET	0x3D
;      60 #endif
;      61 #ifndef ENTR
;      62 #define ENTR	0x3E
;      63 #endif
;      64 
;      65 // Types de seringue
;      66 #define Terumo50CC   	1
;      67 #define Monoject50CC    2
;      68 #define BD20CC          3
;      69 
;      70 // Alphanumeric LCD Module functions
;      71 #asm
;      72    .equ __lcd_port=0x15
   .equ __lcd_port=0x15
;      73 #endasm

;      74 #include <lcd.h>  
;      75 
;      76 
;      77 // Declare your global variables here
;      78 unsigned int Vtimer; // Rglage de la frquence du moteur pas  pas
;      79 
;      80 // Timer 1 overflow interrupt service routine 
;      81 // Sous programme d'interruption "Moteur"
;      82 interrupt [TIM1_OVF] void timer1_ovf_isr(void)
;      83 {

	.CSEG
_timer1_ovf_isr:
	RCALL __SAVEISR
;      84 static unsigned char etat = etat0;

	.DSEG

	.CSEG
;      85 TCNT1 = Vtimer; // rechargement du timer 1
	__OUTWR 4,5,44
;      86 switch(etat) 
	MOV  R30,R6
;      87 	{
;      88        	  case etat0 : PORTB = 9; etat = etat1; break;
	CPI  R30,0
	BRNE _0x25
	LDI  R30,LOW(9)
	OUT  0x18,R30
	LDI  R30,LOW(1)
	MOV  R6,R30
	RJMP _0x24
;      89 	  case etat1 : PORTB = 5; etat = etat2; break;						 
_0x25:
	CPI  R30,LOW(0x1)
	BRNE _0x26
	LDI  R30,LOW(5)
	OUT  0x18,R30
	LDI  R30,LOW(2)
	MOV  R6,R30
	RJMP _0x24
;      90 	  case etat2 : PORTB = 6; etat = etat3; break;
_0x26:
	CPI  R30,LOW(0x2)
	BRNE _0x27
	LDI  R30,LOW(6)
	OUT  0x18,R30
	LDI  R30,LOW(3)
	MOV  R6,R30
	RJMP _0x24
;      91 	  case etat3 : PORTB = 10; etat = etat0; break;
_0x27:
	CPI  R30,LOW(0x3)
	BRNE _0x29
	LDI  R30,LOW(10)
	OUT  0x18,R30
;      92 	  default: etat=etat0;	  
_0x29:
_0x57:
	CLR  R6
;      93 	} 
_0x24:
;      94 }
	RCALL __LOADISR
	RETI
;      95 
;      96 //--------------------
;      97 // Programme principal
;      98 //--------------------
;      99 
;     100 void main(void)
;     101 {
_main:
;     102 // Declare your local variables here
;     103 //----------------------------------
;     104 char display_buffer_ligne0[17]; // tampon ligne 0 de l'afficheur
;     105 char display_buffer_ligne1[17]; // tampon ligne 1 de l'afficheur
;     106 float FPH; // frquence calcule  partir de la consigne de dbit
;     107 unsigned char etat = Arret, etat_1 = Marche; // variables du graphe Menu
;     108 unsigned char BP, seringue=Terumo50CC; // BP = code ou tat de la touche slectionne
;     109 			    // seringue = type de seringue slectionne 
;     110 unsigned int dizaines=0, unites=0, diziemes=0; // slection du dbit  dizaines unites.diziemes ml/h
;     111 unsigned int dix_C_debit; // dix_C_debit = 100*dizaines + 10*unites + diziemes
;     112 
;     113 
;     114 // Input/Output Ports initialization
;     115 // Port A
;     116 PORTA=0x3F;
	SBIW R28,44
	LDI  R24,4
	LDI  R26,LOW(2)
	LDI  R27,HIGH(2)
	LDI  R30,LOW(_0x2B*2)
	LDI  R31,HIGH(_0x2B*2)
	RCALL __INITLOCB
;	display_buffer_ligne0 -> Y+27
;	display_buffer_ligne1 -> Y+10
;	FPH -> Y+6
;	etat -> R16
;	etat_1 -> R17
;	BP -> R18
;	seringue -> R19
;	dizaines -> R20,R21
;	unites -> Y+4
;	diziemes -> Y+2
;	dix_C_debit -> Y+0
	LDI  R16,0
	LDI  R17,1
	LDI  R19,1
	LDI  R20,0
	LDI  R21,0
	LDI  R30,LOW(63)
	OUT  0x1B,R30
;     117 DDRA=0x00;
	CLR  R30
	OUT  0x1A,R30
;     118 
;     119 // Port B
;     120 PORTB=0x00;      		       			
	RCALL SUBOPT_0x0
;     121 DDRB=0x1f;
	LDI  R30,LOW(31)
	OUT  0x17,R30
;     122 
;     123 // Timer/Counter 1 initialization
;     124 // Clock source: System Clock
;     125 // Clock value: 3,906 kHz
;     126 // Mode: Normal top=FFFFh
;     127 // OC1A output: Discon.
;     128 // OC1B output: Discon.
;     129 // Noise Canceler: Off
;     130 // Input Capture on Falling Edge
;     131 TCCR1A=0x00;
	CLR  R30
	OUT  0x2F,R30
;     132 TCCR1B=0x05;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
;     133 TCNT1H=0xFF;
	LDI  R30,LOW(255)
	OUT  0x2D,R30
;     134 TCNT1L=0xFE;
	LDI  R30,LOW(254)
	OUT  0x2C,R30
;     135 OCR1AH=0x00;
	CLR  R30
	OUT  0x2B,R30
;     136 OCR1AL=0x00;
	OUT  0x2A,R30
;     137 OCR1BH=0x00;
	OUT  0x29,R30
;     138 OCR1BL=0x00;
	OUT  0x28,R30
;     139 
;     140 // LCD module initialization
;     141 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
;     142 
;     143 // Global enable interrupts
;     144 #asm("sei")
	sei
;     145 
;     146 
;     147 while (1)
_0x2C:
;     148   {
;     149       BP = Lire_BP();
	RCALL _Lire_BP
	MOV  R18,R30
;     150       
;     151       switch (etat)
	MOV  R30,R16
;     152       {
;     153        case Arret : if (etat_1 != etat)
	CPI  R30,0
	BRNE _0x32
	CP   R16,R17
	BREQ _0x33
;     154                        {
;     155                         PORTB = 0x00;  // dsactivation du moteur
	RCALL SUBOPT_0x0
;     156                         TIMSK=0x00; // inhibition interruption dbordement timer 1
	CLR  R30
	OUT  0x39,R30
;     157                         sprintf(display_buffer_ligne0,"OK>RG_D ETR>CH_S");
	RCALL SUBOPT_0x1
	__POINTW1FN _42,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
;     158                     	sprintf(display_buffer_ligne1,"SET -> RUN");
	RCALL SUBOPT_0x3
	__POINTW1FN _42,17
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
;     159                     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x4
;     160                        }
;     161                     	if (BP==OK) etat = ReglageDebit;
_0x33:
	CPI  R18,55
	BRNE _0x34
	LDI  R16,LOW(2)
;     162                       		else if (BP==SET) etat = Marche;
	RJMP _0x35
_0x34:
	CPI  R18,61
	BRNE _0x36
	LDI  R16,LOW(1)
;     163                       	       		else if (BP==ENTR) etat = ChoixSeringue;
	RJMP _0x37
_0x36:
	CPI  R18,62
	BRNE _0x38
	LDI  R16,LOW(3)
;     164                       		               else etat = Arret;
	RJMP _0x39
_0x38:
	LDI  R16,LOW(0)
_0x39:
_0x37:
_0x35:
;     165        		    etat_1 = Arret; 
	LDI  R17,LOW(0)
;     166        break;
	RJMP _0x31
;     167        		   
;     168        case Marche : if (etat_1 != etat) 
_0x32:
	CPI  R30,LOW(0x1)
	BREQ PC+2
	RJMP _0x3A
	CP   R16,R17
	BRNE PC+2
	RJMP _0x3B
;     169                        { 
;     170                           dix_C_debit = 100*dizaines + 10*unites + diziemes;
	__GETW1R 20,21
	LDI  R26,LOW(100)
	LDI  R27,HIGH(100)
	RCALL __MULW12U
	PUSH R31
	PUSH R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	RCALL __MULW12U
	POP  R26
	POP  R27
	ADD  R30,R26
	ADC  R31,R27
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADD  R30,R26
	ADC  R31,R27
	ST   Y,R30
	STD  Y+1,R31
;     171                          
;     172                        	  switch (seringue)   // Calcul de FPH=f(C_debit)
	RCALL SUBOPT_0x5
;     173                          	{
;     174                          	 case Terumo50CC : FPH = (0.2*dix_C_debit)/10; break;
	BRNE _0x3F
	LD   R30,Y
	LDD  R31,Y+1
	__GETD2N 0x3E4CCCCD
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RCALL __MULF12
	RCALL __MOVED12
	__GETD1N 0x41200000
	RCALL __DIVF21
	__PUTD1S 6
	RJMP _0x3E
;     175                           	 case  ; break; 			      		// <-  complter 
_0x3F:
	CPI  R30,0
	BREQ _0x3E
;     176                           	 case  ; break;       			       		// <-  complter 
	CPI  R30,0
	BRNE _0x3E
;     177                          	} 
_0x3E:
;     178                            
;     179                           Vtimer = ; //calcul de la valeur initiale du timer1   	// <-  complter 
;     180                             
;     181                           sprintf(display_buffer_ligne0,"DEDIT = %-u%-u.%-uml/h",dizaines,unites,diziemes);
	CLR  R4
	CLR  R5
	RCALL SUBOPT_0x1
	__POINTW1FN _42,28
	ST   -Y,R31
	ST   -Y,R30
	__GETW1R 20,21
	RCALL SUBOPT_0x6
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	RCALL SUBOPT_0x6
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	RCALL SUBOPT_0x6
	LDI  R24,12
	RCALL _sprintf
	ADIW R28,16
;     182                           sprintf(display_buffer_ligne1,"Echap -> STOP");
	RCALL SUBOPT_0x3
	__POINTW1FN _42,51
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
;     183                           Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x4
;     184                           TIMSK=0x04; // autorisation interruption dbordement sur timer1
	LDI  R30,LOW(4)
	OUT  0x39,R30
;     185                             
;     186                         }
;     187        		      if (BP==ECHAP) etat = Arret;
_0x3B:
	CPI  R18,59
	BRNE _0x42
	LDI  R16,LOW(0)
;     188                       		else etat = Marche; 
	RJMP _0x43
_0x42:
	LDI  R16,LOW(1)
_0x43:
;     189                       		
;     190                       etat_1 = Marche;
	LDI  R17,LOW(1)
;     191        break;
	RJMP _0x31
;     192                       
;     193        case ReglageDebit: if (etat_1 != etat)
_0x3A:
	CPI  R30,LOW(0x2)
	BRNE _0x44
	CP   R16,R17
	BREQ _0x45
;     194                           { 
;     195                             Regdebit(&dizaines, &unites, &diziemes);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x7
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Regdebit
;     196                             sprintf(display_buffer_ligne0,"Echap -> Arret");
	RCALL SUBOPT_0x1
	__POINTW1FN _42,65
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
;     197                             sprintf(display_buffer_ligne1,"SET   -> RUN");
	RCALL SUBOPT_0x3
	__POINTW1FN _42,80
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
;     198                             Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x4
;     199                           }
;     200        		      
;     201                       	  if (BP==ECHAP) etat = Arret;
_0x45:
	CPI  R18,59
	BRNE _0x46
	LDI  R16,LOW(0)
;     202                       		else if (BP == SET) etat = Marche;
	RJMP _0x47
_0x46:
	CPI  R18,61
	BRNE _0x48
	LDI  R16,LOW(1)
;     203                       		              else etat = ReglageDebit;
	RJMP _0x49
_0x48:
	LDI  R16,LOW(2)
_0x49:
_0x47:
;     204                       
;     205                           etat_1 = ReglageDebit;
	LDI  R17,LOW(2)
;     206        break;
	RJMP _0x31
;     207        
;     208        case ChoixSeringue: if (etat_1 != etat)
_0x44:
	CPI  R30,LOW(0x3)
	BRNE _0x31
	CP   R16,R17
	BREQ _0x4B
;     209                             {
;     210                             	seringue = Select_Seringue();
	RCALL _Select_Seringue
	MOV  R19,R30
;     211                          
;     212                          	switch(seringue)
	RCALL SUBOPT_0x5
;     213                          	{
;     214                          	 case 1 : sprintf(display_buffer_ligne0,"Srg=TERUMO 50CC"); break;
	BRNE _0x4F
	RCALL SUBOPT_0x1
	__POINTW1FN _42,93
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
	RJMP _0x4E
;     215                          	 case 2 : sprintf(display_buffer_ligne0,"Srg=MONO/BD 50CC"); break;
_0x4F:
	CPI  R30,LOW(0x2)
	BRNE _0x50
	RCALL SUBOPT_0x1
	__POINTW1FN _42,109
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
	RJMP _0x4E
;     216                          	 case 3 : sprintf(display_buffer_ligne0,"Seringue=BD 20CC"); break;
_0x50:
	CPI  R30,LOW(0x3)
	BRNE _0x4E
	RCALL SUBOPT_0x1
	__POINTW1FN _42,126
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
;     217                          	}
_0x4E:
;     218                          	sprintf(display_buffer_ligne1,"echp>Arr OK>RG_D"); 
	RCALL SUBOPT_0x3
	__POINTW1FN _42,143
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x2
;     219                          	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x4
;     220                          	
;     221                             } 
;     222                             if (BP==ECHAP) etat = Arret;
_0x4B:
	CPI  R18,59
	BRNE _0x52
	LDI  R16,LOW(0)
;     223                       		else if (BP == OK) etat = ReglageDebit;
	RJMP _0x53
_0x52:
	CPI  R18,55
	BRNE _0x54
	LDI  R16,LOW(2)
;     224                       		              else etat = ChoixSeringue;
	RJMP _0x55
_0x54:
	LDI  R16,LOW(3)
_0x55:
_0x53:
;     225                             etat_1 = ChoixSeringue;
	LDI  R17,LOW(3)
;     226        break;
;     227       }
_0x31:
;     228 
;     229    };
	RJMP _0x2C
;     230 }
	ADIW R28,44
_0x56:
	RJMP _0x56

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	CLR  R30
	OUT  0x18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0x1:
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,27
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x2:
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x3:
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x4:
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,12
	ST   -Y,R31
	ST   -Y,R30
	RJMP _Affiche_LCD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	MOV  R30,R19
	CPI  R30,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x6:
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,6
	RET

__SAVEISR:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R0,SREG
	ST   -Y,R0
	RET

__LOADISR:
	LD   R0,Y+
	OUT  SREG,R0
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RET

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	CLR  R22
	CLR  R23
	SBRS R31,7
	RET
	SER  R22
	SER  R23
	RET

__MOVED12:
	MOV  R26,R30
	MOV  R27,R31
	MOV  R24,R22
	MOV  R25,R23
	RET

__MULW12U:
	MOV  R0,R26
	MOV  R1,R27
	LDI  R24,17
	CLR  R26
	SUB  R27,R27
	RJMP __MULW12U1
__MULW12U3:
	BRCC __MULW12U2
	ADD  R26,R0
	ADC  R27,R1
__MULW12U2:
	LSR  R27
	ROR  R26
__MULW12U1:
	ROR  R31
	ROR  R30
	DEC  R24
	BRNE __MULW12U3
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,24
__MULF120:
	LSL  R19
	ROL  R20
	ROL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	BRCC __MULF121
	ADD  R19,R26
	ADC  R20,R27
	ADC  R21,R24
	ADC  R30,R1
	ADC  R31,R1
	ADC  R22,R1
__MULF121:
	DEC  R25
	BRNE __MULF120
	POP  R20
	POP  R19
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __REPACK
	POP  R21
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __MAXRES
	RJMP __MINRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	LSR  R22
	ROR  R31
	ROR  R30
	LSR  R24
	ROR  R27
	ROR  R26
	PUSH R20
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R25,24
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R1
	ROL  R20
	ROL  R21
	ROL  R26
	ROL  R27
	ROL  R24
	DEC  R25
	BRNE __DIVF212
	MOV  R30,R1
	MOV  R31,R20
	MOV  R22,R21
	LSR  R26
	ADC  R30,R25
	ADC  R31,R25
	ADC  R22,R25
	POP  R20
	TST  R22
	BRMI __DIVF215
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __REPACK
	POP  R21
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM
	ADIW R30,1
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

